org.apache.solr.handler.component

## Class FacetComponent

- java.lang.Object
- - org.apache.solr.handler.component.SearchComponent
  - - org.apache.solr.handler.component.FacetComponent

- All Implemented Interfaces:
    SolrInfoMBean, NamedListInitializedPlugin

      public class FacetComponent
      extends SearchComponent

  Computes facets -- aggregations with counts of terms or ranges over the whole search results.
  Since:
    solr 1.3

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `FacetComponent.DistribFieldFacet` This API is experimental and subject to change
    `static class` | `FacetComponent.FacetBase` This API is experimental and subject to change
    `static class` | `FacetComponent.FacetContext` Encapsulates facet ranges and facet queries such that their parameters are parsed and cached for efficient re-use.
    `static class` | `FacetComponent.FacetInfo` This class is used exclusively for merging results from each shard in a distributed facet request.
    `static class` | `FacetComponent.FieldFacet` This API is experimental and subject to change
    `static class` | `FacetComponent.QueryFacet` This API is experimental and subject to change
    `static class` | `FacetComponent.ShardFacetCount` This API is experimental and subject to change

    - ### Nested classes/interfaces inherited from interface org.apache.solr.core.SolrInfoMBean

      `SolrInfoMBean.Category`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `COMPONENT_NAME`
    `static String` | `FACET_FIELD_KEY`
    `static String` | `FACET_INTERVALS_KEY`
    `static String` | `FACET_QUERY_KEY`
    `static String` | `FACET_RANGES_KEY`
    `static String[]` | `FACET_TYPE_PARAMS`

    - ### Fields inherited from class org.apache.solr.handler.component.SearchComponent

      `standard_components`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `FacetComponent()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `distributedProcess(ResponseBuilder rb)` Process for a distributed search.
    `void` | `finishStage(ResponseBuilder rb)` Called after all responses have been received for this stage.
    `String` | `getDescription()` Simple one or two line description
    `URL[]` | `getDocs()` Documentation URL list.
    `static NamedList<Object>` | `getFacetCounts(SimpleFacets simpleFacets)`
    `static NamedList<Object>` | `getFacetCounts(SimpleFacets simpleFacets, FacetDebugInfo fdebug)` Looks at various Params to determining if any simple Facet Constraint count computations are desired.
    `void` | `handleResponses(ResponseBuilder rb, ShardRequest sreq)` Called after all responses for a single request were received
    `void` | `modifyRequest(ResponseBuilder rb, SearchComponent who, ShardRequest sreq)` Called after another component adds a request
    `void` | `prepare(ResponseBuilder rb)` Prepare the response.
    `void` | `process(ResponseBuilder rb)` Actually run the query

    - ### Methods inherited from class org.apache.solr.handler.component.SearchComponent

      `getCategory, getName, getSource, getStatistics, getVersion, init, setName`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### COMPONENT_NAME

          public static final String COMPONENT_NAME

      See Also:
        Constant Field Values

    - #### FACET_QUERY_KEY

          public static final String FACET_QUERY_KEY

      See Also:
        Constant Field Values

    - #### FACET_FIELD_KEY

          public static final String FACET_FIELD_KEY

      See Also:
        Constant Field Values

    - #### FACET_RANGES_KEY

          public static final String FACET_RANGES_KEY

      See Also:
        Constant Field Values

    - #### FACET_INTERVALS_KEY

          public static final String FACET_INTERVALS_KEY

      See Also:
        Constant Field Values

    - #### FACET_TYPE_PARAMS

          public static String[] FACET_TYPE_PARAMS

  - ### Constructor Detail

    - #### FacetComponent

          public FacetComponent()

  - ### Method Detail

    - #### prepare

          public void prepare(ResponseBuilder rb)
                       throws IOException

      Description copied from class: `SearchComponent`
      Prepare the response. Guaranteed to be called before any SearchComponent `SearchComponent.process(org.apache.solr.handler.component.ResponseBuilder)` method. Called for every incoming request. The place to do initialization that is request dependent.
      Specified by:
        `prepare` in class `SearchComponent`
      Parameters:
        `rb` - The `ResponseBuilder`
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### process

          public void process(ResponseBuilder rb)
                       throws IOException

      Actually run the query
      Specified by:
        `process` in class `SearchComponent`
      Parameters:
        `rb` - The `ResponseBuilder`
      Throws:
        `IOException` - If there is a low-level I/O error.

    - #### getFacetCounts

          public static NamedList<Object> getFacetCounts(SimpleFacets simpleFacets)

    - #### getFacetCounts

          public static NamedList<Object> getFacetCounts(SimpleFacets simpleFacets,
                                                         FacetDebugInfo fdebug)

      Looks at various Params to determining if any simple Facet Constraint count computations are desired.
      Returns:
        a NamedList of Facet Count info or null
      See Also:
        `SimpleFacets.getFacetQueryCounts()`, `SimpleFacets.getFacetFieldCounts()`, `RangeFacetProcessor.getFacetRangeCounts()`, `SimpleFacets.getFacetIntervalCounts()`, `FacetParams.FACET`

    - #### distributedProcess

          public int distributedProcess(ResponseBuilder rb)
                                 throws IOException

      Description copied from class: `SearchComponent`
      Process for a distributed search.
      Overrides:
        `distributedProcess` in class `SearchComponent`
      Returns:
        the next stage for this component
      Throws:
        `IOException`

    - #### modifyRequest

          public void modifyRequest(ResponseBuilder rb,
                                    SearchComponent who,
                                    ShardRequest sreq)

      Description copied from class: `SearchComponent`
      Called after another component adds a request
      Overrides:
        `modifyRequest` in class `SearchComponent`

    - #### handleResponses

          public void handleResponses(ResponseBuilder rb,
                                      ShardRequest sreq)

      Description copied from class: `SearchComponent`
      Called after all responses for a single request were received
      Overrides:
        `handleResponses` in class `SearchComponent`

    - #### finishStage

          public void finishStage(ResponseBuilder rb)

      Description copied from class: `SearchComponent`
      Called after all responses have been received for this stage. Useful when different requests are sent to each shard.
      Overrides:
        `finishStage` in class `SearchComponent`

    - #### getDescription

          public String getDescription()

      Description copied from interface: `SolrInfoMBean`
      Simple one or two line description
      Specified by:
        `getDescription` in interface `SolrInfoMBean`
      Specified by:
        `getDescription` in class `SearchComponent`

    - #### getDocs

          public URL[] getDocs()

      Description copied from interface: `SolrInfoMBean`
      Documentation URL list.

      Suggested documentation URLs: Homepage for sponsoring project, FAQ on class usage, Design doc for class, Wiki, bug reporting URL, etc...

      Specified by:
        `getDocs` in interface `SolrInfoMBean`
      Overrides:
        `getDocs` in class `SearchComponent`

Copyright © 2000-2016 Apache Software Foundation. All Rights Reserved.